org.springframework.cache.ehcache

## Class EhCacheCache

- java.lang.Object
- - org.springframework.cache.ehcache.EhCacheCache

- All Implemented Interfaces:
    Cache

      public class EhCacheCache
      extends Object
      implements Cache

  `Cache` implementation on top of an `Ehcache` instance.
  Since:
    3.1
  Author:
    Costin Leau, Juergen Hoeller, Stephane Nicoll
  See Also:
    `EhCacheCacheManager`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.springframework.cache.Cache

      `Cache.ValueRetrievalException, Cache.ValueWrapper`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EhCacheCache(net.sf.ehcache.Ehcache ehcache)` Create an `EhCacheCache` instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clear the cache through removing all mappings.
    `void` | `evict(Object key)` Evict the mapping for this key from this cache if it is present.
    `boolean` | `evictIfPresent(Object key)` Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.
    `Cache.ValueWrapper` | `get(Object key)` Return the value to which this cache maps the specified key.
    `<T> T` | `get(Object key, Callable<T> valueLoader)` Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary.
    `<T> T` | `get(Object key, Class<T> type)` Return the value to which this cache maps the specified key, generically specifying a type that return value will be cast to.
    `String` | `getName()` Return the cache name.
    `net.sf.ehcache.Ehcache` | `getNativeCache()` Return the underlying native cache provider.
    `boolean` | `invalidate()` Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.
    `void` | `put(Object key, Object value)` Associate the specified value with the specified key in this cache.
    `Cache.ValueWrapper` | `putIfAbsent(Object key, Object value)` Atomically associate the specified value with the specified key in this cache if it is not set already.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EhCacheCache

          public EhCacheCache(net.sf.ehcache.Ehcache ehcache)

      Create an `EhCacheCache` instance.
      Parameters:
        `ehcache` - the backing Ehcache instance

  - ### Method Detail

    - #### getName

          public final String getName()

      Description copied from interface: `Cache`
      Return the cache name.
      Specified by:
        `getName` in interface `Cache`

    - #### getNativeCache

          public final net.sf.ehcache.Ehcache getNativeCache()

      Description copied from interface: `Cache`
      Return the underlying native cache provider.
      Specified by:
        `getNativeCache` in interface `Cache`

    - #### get

          @Nullable
          public Cache.ValueWrapper get(Object key)

      Description copied from interface: `Cache`
      Return the value to which this cache maps the specified key.

      Returns `null` if the cache contains no mapping for this key; otherwise, the cached value (which may be `null` itself) will be returned in a `Cache.ValueWrapper`.

      Specified by:
        `get` in interface `Cache`
      Parameters:
        `key` - the key whose associated value is to be returned
      Returns:
        the value to which this cache maps the specified key, contained within a `Cache.ValueWrapper` which may also hold a cached `null` value. A straight `null` being returned means that the cache contains no mapping for this key.
      See Also:
        `Cache.get(Object, Class)`, `Cache.get(Object, Callable)`

    - #### get

          @Nullable
          public <T> T get(Object key,
                                     @Nullable
                                     Class<T> type)

      Description copied from interface: `Cache`
      Return the value to which this cache maps the specified key, generically specifying a type that return value will be cast to.

      Note: This variant of `get` does not allow for differentiating between a cached `null` value and no cache entry found at all. Use the standard `Cache.get(Object)` variant for that purpose instead.

      Specified by:
        `get` in interface `Cache`
      Parameters:
        `key` - the key whose associated value is to be returned
        `type` - the required type of the returned value (may be `null` to bypass a type check; in case of a `null` value found in the cache, the specified type is irrelevant)
      Returns:
        the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache contains no mapping for this key
      See Also:
        `Cache.get(Object)`

    - #### get

          @Nullable
          public <T> T get(Object key,
                                     Callable<T> valueLoader)

      Description copied from interface: `Cache`
      Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern.

      If possible, implementations should ensure that the loading operation is synchronized so that the specified `valueLoader` is only called once in case of concurrent access on the same key.

      If the `valueLoader` throws an exception, it is wrapped in a `Cache.ValueRetrievalException`

      Specified by:
        `get` in interface `Cache`
      Parameters:
        `key` - the key whose associated value is to be returned
      Returns:
        the value to which this cache maps the specified key
      See Also:
        `Cache.get(Object)`

    - #### put

          public void put(Object key,
                          @Nullable
                          Object value)

      Description copied from interface: `Cache`
      Associate the specified value with the specified key in this cache.

      If the cache previously contained a mapping for this key, the old value is replaced by the specified value.

      Actual registration may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly not seeing the entry yet. This may for example be the case with transactional cache decorators. Use `Cache.putIfAbsent(java.lang.Object, java.lang.Object)` for guaranteed immediate registration.

      Specified by:
        `put` in interface `Cache`
      Parameters:
        `key` - the key with which the specified value is to be associated
        `value` - the value to be associated with the specified key
      See Also:
        `Cache.putIfAbsent(Object, Object)`

    - #### putIfAbsent

          @Nullable
          public Cache.ValueWrapper putIfAbsent(Object key,
                                                          @Nullable
                                                          Object value)

      Description copied from interface: `Cache`
      Atomically associate the specified value with the specified key in this cache if it is not set already.

      This is equivalent to:

           ValueWrapper existingValue = cache.get(key);
           if (existingValue == null) {
               cache.put(key, value);
           }
           return existingValue;

      except that the action is performed atomically. While all out-of-the-box `CacheManager` implementations are able to perform the put atomically, the operation may also be implemented in two steps, e.g. with a check for presence and a subsequent put, in a non-atomic way. Check the documentation of the native cache implementation that you are using for more details.

      The default implementation delegates to `Cache.get(Object)` and `Cache.put(Object, Object)` along the lines of the code snippet above.

      Specified by:
        `putIfAbsent` in interface `Cache`
      Parameters:
        `key` - the key with which the specified value is to be associated
        `value` - the value to be associated with the specified key
      Returns:
        the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache did not contain any mapping for that key prior to this call. Returning `null` is therefore an indicator that the given `value` has been associated with the key.
      See Also:
        `Cache.put(Object, Object)`

    - #### evict

          public void evict(Object key)

      Description copied from interface: `Cache`
      Evict the mapping for this key from this cache if it is present.

      Actual eviction may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entry. This may for example be the case with transactional cache decorators. Use `Cache.evictIfPresent(java.lang.Object)` for guaranteed immediate removal.

      Specified by:
        `evict` in interface `Cache`
      Parameters:
        `key` - the key whose mapping is to be removed from the cache
      See Also:
        `Cache.evictIfPresent(Object)`

    - #### evictIfPresent

          public boolean evictIfPresent(Object key)

      Description copied from interface: `Cache`
      Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.

      The default implementation delegates to `Cache.evict(Object)`, returning `false` for not-determined prior presence of the key. Cache providers and in particular cache decorators are encouraged to perform immediate eviction if possible (e.g. in case of generally deferred cache operations within a transaction) and to reliably determine prior presence of the given key.

      Specified by:
        `evictIfPresent` in interface `Cache`
      Parameters:
        `key` - the key whose mapping is to be removed from the cache
      Returns:
        `true` if the cache was known to have a mapping for this key before, `false` if it did not (or if prior presence could not be determined)
      See Also:
        `Cache.evict(Object)`

    - #### clear

          public void clear()

      Description copied from interface: `Cache`
      Clear the cache through removing all mappings.

      Actual clearing may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entries. This may for example be the case with transactional cache decorators. Use `Cache.invalidate()` for guaranteed immediate removal of entries.

      Specified by:
        `clear` in interface `Cache`
      See Also:
        `Cache.invalidate()`

    - #### invalidate

          public boolean invalidate()

      Description copied from interface: `Cache`
      Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.
      Specified by:
        `invalidate` in interface `Cache`
      Returns:
        `true` if the cache was known to have mappings before, `false` if it did not (or if prior presence of entries could not be determined)
      See Also:
        `Cache.clear()`